; Source created with Parsic Version 3.x

; at              : 13/08/02 12.14.42


; Project File    : c:\PROGRA~1\PARSIC\CONTAT~1\CONTF84.PIC

; Project Version : 1.0.13

; Created         : 25/04/02 13.48.00

; Last change     : 13/08/02 12.14.35

	PROCESSOR 16F84

	INCLUDE P16F84.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

SYS_WSAV	= 12	; located in Bank 0, 1
SYS_SSAV	= 13	; located in Bank 0, 1
TR1	= 14	; located in Bank 0, 1
TR1_HI	= 15	; located in Bank 0, 1
S0	= 16	; located in Bank 0, 1
ZV1	= 17	; located in Bank 0, 1
ZV1_FD	= 18	; located in Bank 0, 1
RAM	= 19	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1


	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 195
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 195
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,0
	GOTO LABEL_TR1_CLR
	BSF S0,0
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,0
LABEL_TR1_ENDE

;***************************************************
; Zhler -> ZV1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BTFSS PORTA,0	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BTFSS S0,0
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BCF STATUS,RP0	; Bank 0
	BTFSC PORTA,1	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCF ZV1,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	DECF ZV1,F

LABEL_ZV1_SETOUT

; Output Q0

	BTFSS ZV1,0
	GOTO LABEL_ZV1_SETOUT0
	BCF STATUS,RP0	; Bank 0
	BSF PORTB,0
	GOTO LABEL_ZV1_SETOUT0_END
LABEL_ZV1_SETOUT0
	BCF STATUS,RP0	; Bank 0
	BCF PORTB,0
LABEL_ZV1_SETOUT0_END

; Output Q1

	BTFSS ZV1,1
	GOTO LABEL_ZV1_SETOUT1
	BSF PORTB,1
	GOTO LABEL_ZV1_SETOUT1_END
LABEL_ZV1_SETOUT1
	BCF PORTB,1
LABEL_ZV1_SETOUT1_END

; Output Q2

	BTFSS ZV1,2
	GOTO LABEL_ZV1_SETOUT2
	BSF PORTB,2
	GOTO LABEL_ZV1_SETOUT2_END
LABEL_ZV1_SETOUT2
	BCF PORTB,2
LABEL_ZV1_SETOUT2_END

; Output Q3

	BTFSS ZV1,3
	GOTO LABEL_ZV1_SETOUT3
	BSF PORTB,3
	GOTO LABEL_ZV1_SETOUT3_END
LABEL_ZV1_SETOUT3
	BCF PORTB,3
LABEL_ZV1_SETOUT3_END

; Output Q4

	BTFSS ZV1,4
	GOTO LABEL_ZV1_SETOUT4
	BSF PORTB,4
	GOTO LABEL_ZV1_SETOUT4_END
LABEL_ZV1_SETOUT4
	BCF PORTB,4
LABEL_ZV1_SETOUT4_END

; Output Q5

	BTFSS ZV1,5
	GOTO LABEL_ZV1_SETOUT5
	BSF PORTB,5
	GOTO LABEL_ZV1_SETOUT5_END
LABEL_ZV1_SETOUT5
	BCF PORTB,5
LABEL_ZV1_SETOUT5_END

; Output Q6

	BTFSS ZV1,6
	GOTO LABEL_ZV1_SETOUT6
	BSF PORTB,6
	GOTO LABEL_ZV1_SETOUT6_END
LABEL_ZV1_SETOUT6
	BCF PORTB,6
LABEL_ZV1_SETOUT6_END

; Output Q7

	BTFSS ZV1,7
	GOTO LABEL_ZV1_SETOUT7
	BSF PORTB,7
	GOTO LABEL_ZV1_SETOUT7_END
LABEL_ZV1_SETOUT7
	BCF PORTB,7
LABEL_ZV1_SETOUT7_END


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BTFSC S0,0
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;****************************************

	GOTO MAIN


	END

